 %macro chk_create_dir(dir_name=); 	  

DATA _NULL_;
	  LENGTH dir_name dir_name_sh new_dir dir_name_remaining $ 1000 slash $ 1 Message $ 200;

		 dir_name=LEFT("&dir_name.");

		IF "&SYSSCP." ="WIN" THEN  slash="\" ;
		ELSE 							             slash="/";

		dir_exist_fl=FILEEXIST(dir_name);
		IF 	dir_exist_fl THEN DO; Message="Directory " || TRIM(dir_name) || " already exist."; PUT Message; END;
		 
		  IF  dir_exist_fl=0;

		IF 	 INDEX(dir_name,slash)=0 THEN new_dir=DCREATE(dir_name) ;  /* Relative path specified. Created in the current directory*/
	    ELSE
						DO;  
		IF 	SUBSTR(dir_name, LENGTH(dir_name),1) NE slash THEN 	 dir_name=CATS(dir_name,slash);

		dir_levels_num=COUNTW(dir_name,slash)-1 ;

		IF 	SUBSTR(dir_name, 1,1)= slash THEN i_min=1; 	   /* Case like \test1 */
		ELSE														   i_min=2; 	/* Case like C:\test1 */

		dir_name_remaining=dir_name;

				    					DO i=i_min TO dir_levels_num;
	
		    dir_name_sh=SCAN(dir_name,i,slash);	
		 	dir_name_sh_length=LENGTH(dir_name_sh);

 			pos=INDEXW(dir_name_remaining,TRIM(dir_name_sh),slash);
			 dir_name_remaining=SUBSTR(dir_name_remaining,pos+dir_name_sh_length);

       IF i= i_min	THEN dir_name_parent=SUBSTR(dir_name,1,pos-1);

		 dir_exist_fl=FILEEXIST(CATS(dir_name_parent,dir_name_sh));

		 IF  dir_exist_fl=0 THEN new_dir=DCREATE(TRIM(dir_name_sh),TRIM(dir_name_parent));
	*	PUT _ALL_;	
        dir_name_parent=TRIM(dir_name_parent)  || TRIM(dir_name_sh) || slash;
     * PUT	dir_name_parent=;
			 						END;
						END;
	
		 IF  new_dir NE " " 	THEN Message="Directory " || TRIM(new_dir) || " has been created.";
		ELSE									Message="Directory " || TRIM(dir_name) || " can not be created. Check permissions."; 
		 PUT Message;
	RUN;
%MEND;